# We only need the first two features...
pca = PCA(n_components=2)
V_k = pca.fit_transform(v_k)
sig = np.sqrt(pca.explained_variance_)

# Let's retrieve the two directions:
mode_1 = tensor( sig[0]*pca.inverse_transform( [1.,0.] ))
mode_2 = tensor( sig[1]*pca.inverse_transform( [0.,1.] ))
mode_1, mode_2 = mode_1.float().view(3,2), mode_2.float().view(3,2)

# Fancy display
M = KendallTriangles()

M.add_markers(a_k,    "green", "A_k", .5) 
M.add_markers(mean, "red",     "mean") 
M.add_markers(exp(mean, mode_1), "blue",  "+e_1") 
M.add_markers(exp(mean,-mode_1), "blue",  "-e_1") 
M.add_markers(exp(mean, mode_2), "cyan",  "+e_2") 
M.add_markers(exp(mean,-mode_2), "cyan",  "-e_2") 

M.generate_spherical_sampled_data()
M.show()
M.show_glyphs()
M.show_pieces()
M.iplot('The principal modes of variation')
