class L2Flow(Model) :
    "Find the optimal mass positions."
    def __init__(self, α) :
        "Defines the parameters of a free deformation of α."
        super(Model, self).__init__()
        self.α_i, self.x_i = α[0].detach(), α[1].detach()
        self.v_i = Parameter(torch.zeros_like(self.x_i))

    def __call__(self, t=1.) :
        "Applies the model on some point cloud, an N-by-2 tensor."
        x_t = self.x_i + t*self.v_i
        return self.α_i, x_t 
    
    def cost(self, target) :
        "Returns a cost to optimize."
        return fidelity( self(), target)
l2flow = train_and_display(L2Flow, α, β)
